//******************************************************************************
//
// 헤더 정의
//
//******************************************************************************
//#include <uSYS.h>

#define NAND_VAR   1
#include <fs/nand.h>
#include <string.h>
#include<migos_stdio.h>

#define TRUE	1
#define	FALSE	0

TNandInfo       Nand1;



//------------------------------------------------------------------------------
// 설명 : 지연
// 주의 : 
//------------------------------------------------------------------------------
void	nand_dumy( void )
{
	return;	
}
void	NAND_AddressSetupWait( void )
{
	int	wait = 250;
	
	while( wait-- ) nand_dumy();
}
//------------------------------------------------------------------------------
// 설명 : BLOCK의 배드 블럭 상태를 체크한다. 
// 매계 : 
// 반환 : 에러 -1  정상 0
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_CheckBadBlock( TNandInfo *NandDev,  int BlockNumber )
{
    	unsigned long Dummy;
    	unsigned long BlockAddr;
    	unsigned char State;
    
    	BlockAddr = (BlockNumber << 5 );
    
    	Dummy = NAND_ACCESS_START;
    	NAND_CMD      =         NAND_CMD_READ_C;     // C Area Read Command               
    	NAND_ADDR     =                   0x05;      // Bad Check Offset      Col                 
    	NAND_ADDR     =  (BlockAddr     & 0xFF);     // Block Page Address L  Row0
    	NAND_ADDR     = ((BlockAddr>>8) & 0xFF);     // Block Page Address M  Row1 
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Block Page Address H  Row2
    	{
        	NAND_ADDR = ((BlockAddr>>16) & 0xFF);
    	}
    	NAND_AddressSetupWait();
    
    	State = NAND_DATA & 0xFF;
    	Dummy = NAND_ACCESS_END;
    
    	NandDev->BadBlock[BlockNumber] = 'O';
    	if( State != 0xFF )
    	{
        	NandDev->BadBlock[BlockNumber] = 'X';
         	return FALSE;
    	}     
    
    	return TRUE;
}

//------------------------------------------------------------------------------
// 설명 : NAND의 BAD 블럭을 검출한다. 
// 매계 : BaseAddress : NAND 플레쉬의 베이스 주소 
//        NandDev     : 검출후 플래쉬 정보 저장 주소 
// 반환 : 배드 블럭 수 
// 주의 : 전체블럭을 확인하지 않고 부트로더에서 사용되는 커널,램디스크영역만 확인한다.
//------------------------------------------------------------------------------
int 	NAND_ScanBadBlock( TNandInfo *NandDev )
{
    	int ScanBlock, IndexBlock;
    	int ReplaceBlock,  VirIndex;
    
    	//ScanBlock = USED_BOOT_BLOCK_COUNT;  //NandDev->TotalSize/NandDev->EraseSize; 
//	ScanBlock = 64+192;	// from ezboot
		ScanBlock = (64+192)*2;	// from ezboot
    	NandDev->BadBlockCount = 0;
    
    	for( IndexBlock = 0; IndexBlock < ScanBlock; IndexBlock++ )
    	{
        	if( NAND_CheckBadBlock( NandDev, IndexBlock ) == FALSE )
        	{
            		NandDev->BadBlockCount++;
        	}
    	}
    	
    	// 배드블럭을 제거한 가상블럭을 정열한다.
    	ReplaceBlock = 0;
    	VirIndex     = 0;
    	for( IndexBlock = 0; IndexBlock < ScanBlock; IndexBlock++ ) 
    	{
        	if ( 'X' == NandDev->BadBlock[IndexBlock] )
        	{
			ReplaceBlock ++;
			continue;
        	}

		if ( ReplaceBlock < ScanBlock )
		{
       			NandDev->VirBlock[VirIndex++] = ReplaceBlock++;
       		}
       		else
       		{
       			NandDev->VirBlock[VirIndex++] = ScanBlock-1;
       		}
    	}
    	
    	return NandDev->BadBlockCount;
}
//------------------------------------------------------------------------------
// 설명 : NAND를 지운다.
// 매계 : NandDev     : NAND 정보 
//        BlockNumber : 블럭 정보 
// 반환 : 에러 FALSE : 정상 TRUE
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_EraseBlock( TNandInfo *NandDev,  int BlockNumber )
{
    	unsigned long Dummy;
    	unsigned long BlockAddr;
    	unsigned char State;
    
        // 이 함수를 호출하기 전에 아래의 내용을 확인한다
    	// if( NandDev->BadBlock[BlockNumber] == 'X' ) return TRUE; // 배드 블럭이면 지우지 않는다. 

    	BlockAddr = BlockNumber << 5;
    	Dummy         = NAND_ACCESS_START;
    	NAND_CMD      =   NAND_CMD_ERASE_SETUP;      // C Area Read Command
    	NAND_ADDR     =  (BlockAddr     & 0xFF);     // Block Page Address L
    	NAND_ADDR     = ((BlockAddr>>8) & 0xFF);     // Block Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Block Page Address H
    	{
        	NAND_ADDR = ((BlockAddr>>16) & 0xFF);    
    	}
    	NAND_AddressSetupWait();

    	NAND_CMD  = NAND_CMD_ERASE_RUN;              // NAND 지우기 실행
    
    	while( 1 )
    	{
    		NAND_CMD  = NAND_CMD_READ_STATE;                         // 현재 상태 요구 명령
    		State     = NAND_DATA & 0xFF;                            // 현재 상태를 읽는다. 
    		if( ( State & NAND_STATUS_BUSY      ) != 0 ) break;      // Busy 상태이면 계속 돈다. 
    	}

    	Dummy     = NAND_ACCESS_END;

    	if( ( State & NAND_STATUS_ERASE_OK  ) != 0 )
    	{
    		kernel_printf( "NAND Erase Block [%d] Fail\n", BlockNumber );
    		if( ( State & NAND_STATUS_PROTECTED ) == 0 )
    		{
        		kernel_printf( "NAND Device Lock\n" );
    		}
    		return FALSE;
    	}
	
/*
	//debuging
  
    	NAND_CMD      = NAND_CMD_READ_A;                           // NAND 읽기 시작 
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     = (BlockNumber << 5) & 0xff;
    	NAND_ADDR     = (BlockNumber >> 3) & 0xff;
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = (BlockNumber >> 11) & 0xff;
    	}
    	NAND_AddressSetupWait();

	kernel_printf( "[%d] %02x %02x\n", BlockNumber, NAND_DATA, NAND_DATA );
*/
	
    	return TRUE;
}

//------------------------------------------------------------------------------
// 설명 : NAND Page를 읽는다. 
// 매계 : NandDev    : NAND 정보
//        PageNumber : 읽으려는 페이지 번호 
//        pBuf       : 512 바이트 크기의 버퍼 주소 
// 반환 : 없음 
// 주의 : 없음 
//------------------------------------------------------------------------------
void 	NAND_ReadPage( TNandInfo *NandDev, int PageNumber, unsigned char *pBuf )
{
    	unsigned long  Dummy;
    	unsigned long  Loop;
    	unsigned char *pReadBuf;
    	unsigned long  *PtrNandData;
    	
    	PtrNandData   = (unsigned long *)&(NAND_DATA);
    	pReadBuf      = pBuf;
    
    	Dummy         = NAND_ACCESS_START;
    
    	NAND_CMD      = NAND_CMD_READ_A;                           // NAND 읽기 시작 
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     =  (PageNumber     & 0xFF);    // Page Address L
    	NAND_ADDR     = ((PageNumber>>8) & 0xFF);    // Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = ((PageNumber>>16) & 0xFF);    
    	}

    	NAND_AddressSetupWait();
    	
    	// 512 바이트를 읽는다. 
    	for( Loop = 0; Loop < 512; Loop++ ) *pReadBuf++ = *PtrNandData;  

    	Dummy     = NAND_ACCESS_END;

}    	
//------------------------------------------------------------------------------
// 설명 : NAND Page에 데이타를 써넣는다. 
// 매계 : NandDev    : NAND 정보
//        PageNumber : 써 넣으려는 페이지 번호 
//        pBuf       : 512 바이트 크기의 버퍼 주소 
// 반환 : 에러 -1  정상 0
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_WritePage( TNandInfo *NandDev, int PageNumber, unsigned char *pBuf )
{	
    	unsigned long  Dummy;
    	unsigned long  Loop;
    	unsigned char  State;
    	unsigned char *pWriteBuf;
    	
    	pWriteBuf = pBuf;	
    
    	Dummy     = NAND_ACCESS_START;
    
    	NAND_CMD      = NAND_CMD_READ_A;             // NAND 읽기 시작 
    	NAND_CMD      = NAND_CMD_WRITE_START;        // NAND 써넣기 시작 
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     =  (PageNumber     & 0xFF);    // Page Address L
    	NAND_ADDR     = ((PageNumber>>8) & 0xFF);    // Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = ((PageNumber>>16) & 0xFF);    
    	}
    	NAND_AddressSetupWait();
    
    	// 512 바이트를 써 넣는다. 
    	for( Loop = 0; Loop < 512 ; Loop++ ) NAND_DATA = *pWriteBuf++;
    
    	NAND_CMD  = NAND_CMD_WRITE_RUN;                          // NAND 써넣기 실행 
    
    	while( 1 )
    	{
        	NAND_CMD  = NAND_CMD_READ_STATE;                         // 현재 상태 요구 명령
    		State     = NAND_DATA & 0xFF;                        // 현재 상태를 읽는다. 
    		if( ( State & NAND_STATUS_BUSY      ) != 0 ) break;  // Busy 상태이면 계속 돈다. 
    	}
    	Dummy = NAND_ACCESS_END;
    
    	if( ( State & NAND_STATUS_PROGRAM_OK ) == 0 ) return TRUE;
    	kernel_printf( "NAND Write  Fail\n" );
    
    	if( ( State & NAND_STATUS_PROTECTED  ) == 0 ) 
    	{
        	kernel_printf( "NAND Device Lock\n" );
    	}    

    	return FALSE;
}

//------------------------------------------------------------------------------
// 설명 : Sector 인덱스를 Page 인덱스로 변경하여 가져 온다. 
// 매계 : NandDev         : 플래쉬 정보 저장 주소 
//        PartitionNumber : 파티션 번호 
//        SectorNumber    : 섹터 번호 
// 반환 : 실제 페이지번호 
// 주의 : 없음 
//------------------------------------------------------------------------------
int 	NAND_GetPageFromSector( TNandInfo *NandDev, int SectorNumber )
{
    	int	VirBlock;	// 배드블럭을 건너띤 가상블럭
    	int 	RealBlock;	// 실제블럭
    
    	RealBlock = SectorNumber / 32;
	VirBlock  = NandDev->VirBlock[RealBlock];
	
	if ( 0xffff == VirBlock ) return -1;

	return ( VirBlock*32 + (SectorNumber%32) );
}
//------------------------------------------------------------------------------
// 설명 : NAND Sector에 데이타를 써넣는다. 
// 매계 : NandDev    : NAND 정보
//        PageNumber : 써 넣으려는 페이지 번호 
//        pBuf       : 512 바이트 크기의 버퍼 주소 
// 반환 : 에러 -1  정상 0
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_WriteSector( TNandInfo *NandDev, int SectorNumber, unsigned char *pBuf )
{
    	int PageNumber;
    	int BlockNumber;
    
    	PageNumber = NAND_GetPageFromSector( NandDev, SectorNumber );
    	if( PageNumber < 0 ) return FALSE;
    
    	BlockNumber = PageNumber / 32;
    
    	// 포함 범위 체크 
	/*
    	if( NandDev->pPartition[PartitionNumber].BaseBlock > BlockNumber ) return FALSE;
    	if( (  NandDev->pPartition[PartitionNumber].BaseBlock 
        	 + NandDev->pPartition[PartitionNumber].BlockCount ) <= BlockNumber ) return FALSE;
	*/

    	// 데이타를 써 놓고 복귀 한다.    
    	return NAND_WritePage( NandDev, PageNumber, pBuf );
} 
//------------------------------------------------------------------------------
// 설명 : NAND Sector를 읽는다. 
// 매계 : NandDev    : NAND 정보
//        PageNumber : 읽으려는 페이지 번호 
//        pBuf       : 512 바이트 크기의 버퍼 주소 
// 반환 : 없음 
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_ReadSector( TNandInfo *NandDev, int SectorNumber, unsigned char *pBuf )
{
    	int PageNumber;
    	int BlockNumber;
    
    	PageNumber = NAND_GetPageFromSector( NandDev, SectorNumber );
    	if( PageNumber < 0 ) return FALSE;
    
    	BlockNumber = PageNumber / 32;
    
    	// 포함 범위 체크 
	/*
    	if( NandDev->pPartition[PartitionNumber].BaseBlock > BlockNumber ) return FALSE;
    	if( (  NandDev->pPartition[PartitionNumber].BaseBlock 
        	 + NandDev->pPartition[PartitionNumber].BlockCount ) <= BlockNumber ) return FALSE;
	*/

    	NAND_ReadPage( NandDev, PageNumber, pBuf );
    	

    	return TRUE;
}

//------------------------------------------------------------------------------
// 설명 : NAND를 검출한다. 
// 매계 : BaseAddress : NAND 플레쉬의 베이스 주소 
//        NandDev     : 검출후 플래쉬 정보 저장 주소 
//        
// 반환 : 에러 FALSE 정상 TRUE
// 주의 : 없음 
//------------------------------------------------------------------------------
BOOL 	NAND_DETECT( unsigned long BaseAddress , TNandInfo *NandDev )
{
    	unsigned char  MakerID, SizeID;
    	unsigned short Dummy;
    	//int            Loop;
    	//int            RestBlockCount;
    	
    	kernel_printf( "NAND Chip Check .......................\n" );
    	//kernel_printf( "  Base Address [%08X]\n", (unsigned int)BaseAddress );
    
    	NandDev->BaseAddress = BaseAddress;
  
    	Dummy     = NAND_ACCESS_START;
    	NAND_CMD  = NAND_CMD_READ_ID;                             // ID 읽기 명령
    	NAND_ADDR = 0x00;                                         // 명령어 이후 부가적인 행동

    	MakerID   = NAND_DATA & 0xFF;                             // 제조사 읽기 
    	SizeID    = NAND_DATA & 0xFF;                             // 크기 읽기 
    	Dummy     = NAND_ACCESS_END;
    
    	//kernel_printf( "  NAND Maker ID [%02X]  ", MakerID );
    	//kernel_printf( "  NAND Size  ID [%02X]\n", SizeID );
    
    	NandDev->Type      = NAND_TYPE_UNKNOW;
    	switch( MakerID )
    	{
    	case 0xEC : 
                switch( SizeID )
                {
                case 0x73 : NandDev->Type = NAND_TYPE_SAMSUNG_16M ; 
                            NandDev->TotalSize =  16 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x75 : NandDev->Type = NAND_TYPE_SAMSUNG_32M ; 
                            NandDev->TotalSize =  32 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x76 : NandDev->Type = NAND_TYPE_SAMSUNG_64M ; 
                            NandDev->TotalSize =  64 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x79 : NandDev->Type = NAND_TYPE_SAMSUNG_128M; 
                            NandDev->TotalSize = 128 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                }
                break;
    	} 
    
    	switch( NandDev->Type )
    	{
    	case NAND_TYPE_SAMSUNG_16M  : kernel_printf( "  Detect SAMSUNG [%02x:%02x] 16MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_32M  : kernel_printf( "  Detect SAMSUNG [%02x:%02x] 32MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_64M  : kernel_printf( "  Detect SAMSUNG [%02x:%02x] 64MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_128M : kernel_printf( "  Detect SAMSUNG [%02x:%02x] 128MByte\n", MakerID, SizeID ); break;
    	default                     : kernel_printf( "  Unknown Type\n"      ); break; 
    	}
    
    	if( NandDev->Type == NAND_TYPE_UNKNOW ) return FALSE;

    	// BAD 블럭 스캔 
    	kernel_printf( "  BAD BLOCK SCAN ->" );
    	kernel_printf( "  Kernel, Ramdisk Bad Block [%d]\n", NAND_ScanBadBlock( NandDev ) );

    	return TRUE;
}
//------------------------------------------------------------------------------
// 설명 : NAND-Flash 를 찾는다.
// 주의 : 없음
//------------------------------------------------------------------------------
int	NandFlash_Init( void )
{
	NAND_DETECT( NAND_BASE, &Nand1 );

	return 0;
}

void nand_print_sector( int sector )
{
	char buf[512];
	//int i;
	memset( buf, 0, 512 );
	NAND_ReadSector( &Nand1, sector, buf );
	//print_dump_memory( buf, 512, 16 );
}

int nand_open( void )
{
	kernel_printf("[dev] nand flash ... open\n");
	return 1;
}

int nand_read( void* buf, int len )
{
	return 1;
}

int nand_write( void* buf, int len )
{
	return 1;
}

int nand_ioctl( void* wbuf, int wlen, void* rbuf, int rlen )
{
	return 1;
}

int nand_close( void )
{
	kernel_printf("[dev] nand flahs ... close \r\n");
	return 1;
}

int nand_term( void )
{
	return 1;
}

int init_nand( void )
{
	kernel_printf("nand_flash... init\r\n");

	NandFlash_Init();

	return 1;
}



