#ifndef __MEM_H__
#define __MEM_H__

/*
 *	DEFINE VARIABLE
 */
#define PHYSICAL_MEM_START	0xA0000000
#define PHYSICAL_MEM_END	0xA4000000
#define PHYSICAL_MEME_SIZE	(PHYSICAL_MEM_END - PHYSICAL_MEM_START)

#define DYNAMIC_MEM_BASE	0xA2000000
#define DYNAMIC_MEM_OFFSET	0x4
#define	DYNAMIC_MEM_START	(DYNAMIC_MEM_BASE + DYNAMIC_MEM_OFFSET)

#define VERIFY_VALUE		0x11223344

#define MEM_BLOCK_SIZE		1024
#define MAX_BLOCK_COUNT		((PHYSICAL_MEM_END-DYNAMIC_MEM_START)/MEM_BLOCK_SIZE)
#define	START_BLOCK_INDEX	0
#define	END_BLOCK_INDEX		0xFFFFFFFF

/*
 *	GLOBAL VARIABLE
 */

extern unsigned int*	dynamic_mem_start;

/*
 *	VARIABLE PROTOTYPE
 */

typedef struct _block_mgmt {
	unsigned char	*block;
} block_mgmt;

typedef struct _block_used {
	unsigned int	*base_addr;
	unsigned int	bsize;
	unsigned char	used;
	unsigned int	prev;
	unsigned int	next;
} block_used;

/*
 *	FUNCTION PROTOTYPE
 */

#if 0
extern uint init_mem(void);
extern void *malloc(uint size);
extern uint free(void *pt);
extern uint print_blk_status(void);
#endif

#endif /* __MEM_H__ */
