#ifndef __BLIST_H__
#define __BLIST_H__

typedef struct _blist_node
{
	struct _blist_node* next;
	struct _blist_node* prev;
}blist_node;

typedef struct _blist
{
	blist_node* head;
	blist_node* tail;
}blist;

void blist_add_head( blist* l, void* item );
void blist_add_tail( blist* l, void* item );
void blist_remove( blist* l, void* item );
int blist_count( blist* l );
int blist_exist( blist* l, void* item );

#define BNODE_OFFSET( type, field ) ( (int)&((type*)0)->field )
#define BNODE_ITEM_ADDR( pnode, type, field ) 	( (type*)((int)pnode-BNODE_OFFSET(type,field) ) )

#endif
