/*/////////////////////////////////////////////////////////////////
 ROMFS by bro
 ========================================================
 ROMFS implememtation spec

  - mini rom filesystem on RAM memory
  - FAT16 support
 
 --------------------------------------------------------
 2004-07-19 | initial code ( romfs_path with root path )
 2004-07-20 | romfs_path 
 2004-07-26 | romfs_file functions
              limit file size = FAT12:<20M FAT16:<500MB  logical:<2097MB
/////////////////////////////////////////////////////////////////*/
#ifndef __ROMFS_H__
#define __ROMFS_H__

#include <fs/fat.h>

#define uSYS_FS_IMAGE_SIZE		1*1024*1024
#define uSYS_FS_RAM_BASE		0xA0800000
//#define uSYS_FS_NAND_BASE_SECTOR	(32*0)	// 4M
//#define uSYS_FS_NAND_BASE_SECTOR	(80)	// 0x0001 0000 
#define uSYS_FS_NAND_BASE_SECTOR	(4096*2)	// 4M


int init_fs( void );


typedef struct _rom_storage
{
	// rom fat image on ram memory
	void*		address;
	int			size;
	sector_io	sio;
}rom_storage;

int rom_storage_read_sector( sector_io* sio, int sector, int offset, int8u* buf, int size );
int rom_storage_write_sector( sector_io* sio, int sector, int offset, int8u* buf, int size );

int init_rom_storage( rom_storage* st, void* address, int size );



extern fatfs g_fatfs;
extern rom_storage g_st;


#endif // __ROMFS_H__
