/*************************************************************************** 
 * File        : mm.h
 * Date        : 2007/04/04
 * Author      : Sun Joon Gyu
 * Modified    : 2007/04/04
 * Description : Header file for memory management
 * ***************************************************************************/
#ifndef	_MM_H
#define _MM_H
#ifndef MM_TEST
#include<types.h>
#include<list.h>
//#include<arch/port.h>

#else
#include"types.h"
#include"list.h"
#endif

/* These definition is temporarily used here */
#define MEM_COMPACTION 
/*********************************************/



/**** These definitions should be moved to hardware dependant code  ********/
#define START_HEAP_ADDR		((int32u *)0xa1000000) 
#define END_HEAP_ADDR		((int32u *)( ((int8u *)START_HEAP_ADDR)+SIZE_OF_HEAP))
//#define BLOCK_SIZE		(sizeof(struct memHead)) /* Size of one block */ 
#define BLOCK_SIZE			(64) /* Size of one block */ 
#define	BLOCK_SIZE_SHIFT		(5)
#define SIZE_OF_HEAP		(2*1024*1024)
#define NUM_OF_BLOCKS		(SIZE_OF_HEAP >> BLOCK_SIZE_SHIFT)
/*****************************************************************************/ 

#define BITS_PER_BYTE		 8
#define BACKWARD		 ((int8u)0)
#define FORWARD			 ((int8u)1)

#define INVALID			0x0
#define AVAILABLE		0x1
#define ALLOCATED		0x2

/* Definition for type of memory control block */
struct mm_clt {
	int32s nblocks;

	struct list_head memLink;
	struct list_head allocLink;
	struct list_head freeMemLink;
	int32u threadID;	
	int32u status;		/* status of this memory control block */
	
#ifdef MEM_COMPACTION /* Not implemented yet */
	int32u *pVar;	/*the size of a tcb will be expanded if MEM_COMPACTION is defined */
#endif // MEM_COMPACTION

};


extern int8s heap[];
extern bool kmem_init(void);
extern int32u *k_malloc(size_t size);
static struct mm_clt *find_wanted_blk(size_t size);
static int8s get_mem_blk(struct mm_clt * pBlkAddr, size_t size);
int32u get_free_mem_info();
int32u get_alloc_mem_info(struct mm_clt *head);
int32u get_total_mem_info(struct mm_clt *head);



extern int8s k_free(void *pDesired);
static bool merge_mem_blk(struct mm_clt * pPrevBlk, struct mm_clt * pNextBlk, int8u dir);
	
//extern int8s Kern_BlkTblRegister(struct mm_clt * pBlkAddr);



extern int32u *pHeapList_g;


extern struct mm_clt *pHeapListHead_g;	/* a head for memory controller list*/
extern struct mm_clt *pFirstHeapHead_g;	/* a first block for heap spaces */
	
#endif // _MM_H_ 
