#ifndef _PROCESS_H
#define _PROCESS_H

#include<global.h>
#include<kernel/thread.h>
#include<kernel/resource.h>
#include<kernel/vfs.h>
#include<kernel/mm.h>
#include<kernel/error.h>
#include<types.h>
#include<list.h>


struct process 
{
	int process_id;
	char name[32];
	enum 
	{
		KERNEL_PROCESS,
		JAVA_PROCESS
	}process_type;
	enum
	{
		CREATED,
		PREPARE_INTERPRET,
		INTERPRETING,
		DONE
	}state;
	THREAD *current_thread;
	THREAD *main_thread;
	struct list_head thread_list;
	int alive_thread_count;
	int timeslice;
	struct mm_clt mem_header;
	STACK java_stack;
	void *private;
	struct resource *resources;
	struct file file_table;
	int fd_count;
	struct list_head proc_list;
	THREAD *waitingThread;
	struct console *console;
	void *sys_stack;
	struct heap heap_info;
	struct jproc_exec *java_exec_env;
};



struct jproc_exec
{
	HASHTABLE InternStringTable;
	HASHTABLE UTFStringTable;
	HASHTABLE ClassTable;
	cellOrPointer GlobalRoots[20];
	int GlobalRootsLength;
	cellOrPointer TemporaryRoots[50];
	int TemporaryRootsLength;
	struct process *Process;
};


#define get_current_process()	current_process
#define get_process_list_head()	(&process_list_head_g)

extern struct process *current_process;
extern struct process init_process;
extern struct process process_list_head_g;


extern setup_swapper(void);
extern setup_swapper_process(void);
extern struct mm_clt * get_process_mm_info(struct process *proc);

#endif // _PROCESS_H
