#ifndef _SCHEDULE_H
#define _SCHEDULE_H
#include <kernel/thread.h>

#define MAX_THREAD_PRIO		(128)
#define RR_THREAD_PRIO		(128)

#define is_time_to_resched()	\
		((get_current_thread()->timeslice-- == 0 ) ? 1 : 0 )

#define get_rq()		(&rqueue_g)
#define get_rt_rq()		(&rt_rqueue_g)
#define get_waitq()		(&waitq_g)


#define PRIO_SCHED		(1)
#define RR_SCHED		(0)



extern struct thread rqueue_g;
extern struct thread rt_rqueue_g;
extern struct thread waitq_g;
extern void schedule(void);
extern void init_sched(void);
extern void start_sched(void);

#endif // _SCHEDULE_H
