#ifndef _THREAD_H
#define _THREAD_H

//#include <kernel/resource.h>
#include <global.h>
#include <kernel/process.h>
#include <kernel/mm.h>
#include <list.h>
#include <types.h>

#define MAX_NUM_THREAD_NAME		(64)
#define DEFAULT_TIMESLICE		(100)
#define KERNEL_STACK_SIZE		(1 << KERNEL_STACK_SIZE_SHIFT)
#define KERNEL_STACK_SIZE_SHIFT (13)

#define	get_current_thread()	(current_thread)
extern struct thread *current_thread;

typedef enum { REALTIME, NORMAL }emergency ;

#if 1
struct thread {
		unsigned int stack_top;
		unsigned char stack[KERNEL_STACK_SIZE];
		unsigned int stack_bottom;

		int thread_id;
		char name[MAX_NUM_THREAD_NAME];
		enum {
				INITIAL,
				READY,
				RUNNING,
				BLOCK,
				SLEEP,
				HALT
		}state;
		enum {
				KERNEL_THREAD,
				JAVA_THREAD
		} thread_type;

		emergency rt_fact;

		struct process *parent_proc;
		struct jproc_exec *java_exec_env;
		THREAD java_thread;
//		struct resource resources;

		struct list_head thread_list;
		struct list_head rdy_list;
		struct list_head wait_list;
		struct mm_clt mem_header;

		int timeslice;
		unsigned int priority;



		void *private;

};

#endif


int setup_swapper_thread(void);
struct thread *create_kernel_thread(int thread_id, char *name, fp_t entry, emergency rt_fact, int priority);
void wait_thread(struct thread *);
void wake_up_thread(struct thread *wake);
int initialize_kthread(int thread_id, fp_t entry, int priority, struct thread *new_thread, emergency rt_fact);
int initialize_jthread(int thread_id, fp_t entry, int priority, struct process *parent, struct thread *new_thread);
void yield_thread(void);
int add_thread_to_waitq(struct thread *new_thread, struct thread *queue);
int add_thread_to_rq(struct thread *new_thread, struct thread *queue);
struct thread *find_thread_by_id(int id);
int kill(int id);


#endif // _THREAD_H
