#ifndef _TIMER_H
#define _TIMER_H
#include<list.h>
#include<kernel/thread.h>

struct timer {
		enum {
				JAVA_TIMER,
				KERNEL_TIMER
		}type;
		int timeout;
		void (*fn)(struct thread *);
		struct thread *current;
		struct list_head timer_list;
};



int init_timer(void);
int request_timer(int timeout, void (*fn)(struct thread *));
int request_timer_thread(struct thread *this_thread,int timeout, void (*fn)(struct thread *));
int cancel_timer(struct timer *del_timer);
void update_timer(void);
void sleep(int sec);
int sleep_thread(struct thread *this_thread,int sec);
void usleep(int usec);
void delay(int time);
void udelay(int time);
void print_timer(void);
int is_timer_reserved(struct thread *this_thread);
void remove_reserved_alarm(struct thread *this_thread);
#endif // _TIMER_H
