#include <blist.h>

void blist_add( blist* l, void* item )
{
	blist_node* i = (blist_node*)item;

	if( l->head )
	{
		i->next = l->head;
		l->head->prev = i;
	}
	else
		i->next = 0;
	i->prev = 0;
	l->head = i;
	if( !l->head )
		l->head = i;
}

void blist_add_tail( blist* l, void* item )
{
	blist_node* i = (blist_node*)item;

	if( l->tail )
	{
		i->prev = l->tail;
		l->tail->next = i;
	}
	else
		i->prev = 0;
	i->next = 0;
	l->tail = i;
	if( !l->head )
		l->head = i;
}	

void blist_remove( blist* l, void* item )
{
	blist_node* i = (blist_node*)item;

	if( i->next )
		i->next->prev = i->prev;
	if( i->prev )
		i->prev->next = i->next;
	if( l->head == i )
		l->head = i->next;
	if( l->tail == i )
		l->tail = i->prev;
	i->next = i->prev = 0;
}

int blist_count( blist* l )
{
	int count = 0;
	blist_node* i = l->head;
	while( i )
	{
		count++;
		i = i->next;
	}
	return count;
}

int blist_exist( blist* l, void* item )
{
	blist_node* i = l->head;
	while( i )
	{
		if( i == item )
			return 1;
		i = i->next;
	}
	return 0;
}
