#include <cqa.h>

void cqa_init( cqa* cq, void* array, int count )
{
	cq->array = (CQA_DATA*)array;
	cq->count = count;
	cq->top = CQA_EMPTY;
	cq->bottom = CQA_EMPTY;
}

void cqa_push( cqa* cq, CQA_DATA data )
{
	if( cq->top == CQA_EMPTY )
		cq->bottom = cq->top = 0;
	else
	if( cq->top == cq->bottom ) // full
		cq->bottom = (cq->bottom+1)%cq->count;

	cq->top = (cq->top+1)%cq->count;
	cq->array[ cq->top ] = data;
}

CQA_DATA cqa_pop( cqa* cq )
{
	CQA_DATA i;

	if( cq->top == CQA_EMPTY ) // empty 
		return CQA_EMPTY;

	cq->bottom = (cq->bottom+1)%cq->count;
	
	i = cq->array[ cq->bottom ];

	if( cq->top == cq->bottom ) // empty
		cq->top = CQA_EMPTY;

	return i;
}

