/***************************************************************************** 
 * File        : clock_irq.c
 * Date        : 2008/02/25
 * Author      : Hong Jin Wook
 * Modified    : 2008/02/25
 * Description : Rutines for clock & timer initializing
 * ***************************************************************************/
#include<stdio.h>

static volatile int clock_counter;

//#ifdef SCATTER_PERIP

#include <arch/intgrt_struct.h>
extern struct irq irq0;
extern struct timer_struct timer1;
#define IRQEnableClear irq0.EnableClear
#define IRQEnableSet irq0.EnableSet
#define Timer1Load timer1.Load
#define Timer1Value timer1.Value
#define Timer1Control timer1.Control
#define Timer1Clear timer1.Clear

/*
unsigned int ref_clock(void)
{
    int clk, count;
    clk=clock_counter;
    count=Timer1Value;
    if (clk==clock_counter)  // A timer IRQ did not occur between the counter and timer values being read.
    {
        return clk*15000+(15000-count);
    }
    else                     // A timer IRQ did occur between the counter and timer values being read
    {
        return (clk+1)*15000;
    }
}
*/

void init_clock(void)
{
    clock_counter = 0;
    Timer1Load = 15000;            // With /16, sets 1/100 seconds.
    Timer1Control = 0xC4;          // Periodic mode, Divide by 16, enabled.
    IRQEnableClear = 0x0000003F;   // Disable all interrupts in IRQ controller.
    IRQEnableSet = 0x10;           // Enable Timer1 IRQ (IRQs should still be disabled in the core.
    printf("clock set!!\n");
}

void enable_clock(void)
{
	IRQEnableClear = 0x0000002F;		//	Enable Timer1 IRQ (IRQs should still be disabled in the core.
	printf("clock on!!\n");
}

__irq void inc_clock(void)
{
    Timer1Clear = 0;              // Clear the interrupt
    clock_counter++;              // And increment our 1/100 second clock.
}

