//******************************************************************************
//
//  
//
//******************************************************************************
#include <uSYS.h>

#define NAND_VAR   1
#include <nand.h>
#include <dump.h>
#include <string.h>


TNandInfo       Nand1;


//------------------------------------------------------------------------------
//  : 
//  : 
//------------------------------------------------------------------------------
void	nand_dumy( void )
{
	return;	
}
void	NAND_AddressSetupWait( void )
{
	int	wait = 250;
	
	while( wait-- ) nand_dumy();
}
//------------------------------------------------------------------------------
//  : BLOCK   ¸ üũѴ. 
// Ű : 
// ȯ :  -1   0
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_CheckBadBlock( TNandInfo *NandDev,  int BlockNumber )
{
    	unsigned long Dummy;
    	unsigned long BlockAddr;
    	unsigned char State;
    
    	BlockAddr = (BlockNumber << 5 );
    
    	Dummy = NAND_ACCESS_START;
    	NAND_CMD      =         NAND_CMD_READ_C;     // C Area Read Command               
    	NAND_ADDR     =                   0x05;      // Bad Check Offset      Col                 
    	NAND_ADDR     =  (BlockAddr     & 0xFF);     // Block Page Address L  Row0
    	NAND_ADDR     = ((BlockAddr>>8) & 0xFF);     // Block Page Address M  Row1 
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Block Page Address H  Row2
    	{
        	NAND_ADDR = ((BlockAddr>>16) & 0xFF);
    	}
    	NAND_AddressSetupWait();
    
    	State = NAND_DATA & 0xFF;
    	Dummy = NAND_ACCESS_END;
    
    	NandDev->BadBlock[BlockNumber] = 'O';
    	if( State != 0xFF )
    	{
        	NandDev->BadBlock[BlockNumber] = 'X';
         	return FALSE;
    	}     
    
    	return TRUE;
}

//------------------------------------------------------------------------------
//  : NAND BAD  Ѵ. 
// Ű : BaseAddress : NAND ÷ ̽ ּ 
//        NandDev     :  ÷   ּ 
// ȯ :    
//  : ü Ȯ ʰ Ʈδ Ǵ Ŀ,ũ ȮѴ.
//------------------------------------------------------------------------------
int 	NAND_ScanBadBlock( TNandInfo *NandDev )
{
    	int ScanBlock, IndexBlock;
    	int ReplaceBlock,  VirIndex;
    
    	//ScanBlock = USED_BOOT_BLOCK_COUNT;  //NandDev->TotalSize/NandDev->EraseSize; 
//	ScanBlock = 64+192;	// from ezboot
    	NandDev->BadBlockCount = 0;
    
    	for( IndexBlock = 0; IndexBlock < ScanBlock; IndexBlock++ )
    	{
        	if( NAND_CheckBadBlock( NandDev, IndexBlock ) == FALSE )
        	{
            		NandDev->BadBlockCount++;
        	}
    	}
    	
    	//    Ѵ.
    	ReplaceBlock = 0;
    	VirIndex     = 0;
    	for( IndexBlock = 0; IndexBlock < ScanBlock; IndexBlock++ ) 
    	{
        	if ( 'X' == NandDev->BadBlock[IndexBlock] )
        	{
			ReplaceBlock ++;
			continue;
        	}

		if ( ReplaceBlock < ScanBlock )
		{
       			NandDev->VirBlock[VirIndex++] = ReplaceBlock++;
       		}
       		else
       		{
       			NandDev->VirBlock[VirIndex++] = ScanBlock-1;
       		}
    	}
    	
    	return NandDev->BadBlockCount;
}
//------------------------------------------------------------------------------
//  : NAND .
// Ű : NandDev     : NAND  
//        BlockNumber :   
// ȯ :  FALSE :  TRUE
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_EraseBlock( TNandInfo *NandDev,  int BlockNumber )
{
    	unsigned long Dummy;
    	unsigned long BlockAddr;
    	unsigned char State;
    
        //  Լ ȣϱ  Ʒ  ȮѴ
    	// if( NandDev->BadBlock[BlockNumber] == 'X' ) return TRUE; //  ̸  ʴ´. 

    	BlockAddr = BlockNumber << 5;
    	Dummy         = NAND_ACCESS_START;
    	NAND_CMD      =   NAND_CMD_ERASE_SETUP;      // C Area Read Command
    	NAND_ADDR     =  (BlockAddr     & 0xFF);     // Block Page Address L
    	NAND_ADDR     = ((BlockAddr>>8) & 0xFF);     // Block Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Block Page Address H
    	{
        	NAND_ADDR = ((BlockAddr>>16) & 0xFF);    
    	}
    	NAND_AddressSetupWait();

    	NAND_CMD  = NAND_CMD_ERASE_RUN;              // NAND  
    
    	while( 1 )
    	{
    		NAND_CMD  = NAND_CMD_READ_STATE;                         //   䱸 
    		State     = NAND_DATA & 0xFF;                            //  ¸ д´. 
    		if( ( State & NAND_STATUS_BUSY      ) != 0 ) break;      // Busy ̸  . 
    	}

    	Dummy     = NAND_ACCESS_END;

    	if( ( State & NAND_STATUS_ERASE_OK  ) != 0 )
    	{
    		printf( "NAND Erase Block [%d] Fail\n", BlockNumber );
    		if( ( State & NAND_STATUS_PROTECTED ) == 0 )
    		{
        		printf( "NAND Device Lock\n" );
    		}
    		return FALSE;
    	}
	
/*
	//debuging
  
    	NAND_CMD      = NAND_CMD_READ_A;                           // NAND б  
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     = (BlockNumber << 5) & 0xff;
    	NAND_ADDR     = (BlockNumber >> 3) & 0xff;
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = (BlockNumber >> 11) & 0xff;
    	}
    	NAND_AddressSetupWait();

	printf( "[%d] %02x %02x\n", BlockNumber, NAND_DATA, NAND_DATA );
*/
	
    	return TRUE;
}

//------------------------------------------------------------------------------
//  : NAND Page д´. 
// Ű : NandDev    : NAND 
//        PageNumber :   ȣ 
//        pBuf       : 512 Ʈ ũ  ּ 
// ȯ :  
//  :  
//------------------------------------------------------------------------------
void 	NAND_ReadPage( TNandInfo *NandDev, int PageNumber, unsigned char *pBuf )
{
    	unsigned long  Dummy;
    	unsigned long  Loop;
    	unsigned char *pReadBuf;
    	unsigned long  *PtrNandData;
    	
    	PtrNandData   = (unsigned long *)&(NAND_DATA);
    	pReadBuf      = pBuf;
    
    	Dummy         = NAND_ACCESS_START;
    
    	NAND_CMD      = NAND_CMD_READ_A;                           // NAND б  
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     =  (PageNumber     & 0xFF);    // Page Address L
    	NAND_ADDR     = ((PageNumber>>8) & 0xFF);    // Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = ((PageNumber>>16) & 0xFF);    
    	}

    	NAND_AddressSetupWait();
    	
    	// 512 Ʈ д´. 
    	for( Loop = 0; Loop < 512; Loop++ ) *pReadBuf++ = *PtrNandData;  

    	Dummy     = NAND_ACCESS_END;

}    	
//------------------------------------------------------------------------------
//  : NAND Page Ÿ ִ´. 
// Ű : NandDev    : NAND 
//        PageNumber :    ȣ 
//        pBuf       : 512 Ʈ ũ  ּ 
// ȯ :  -1   0
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_WritePage( TNandInfo *NandDev, int PageNumber, unsigned char *pBuf )
{	
    	unsigned long  Dummy;
    	unsigned long  Loop;
    	unsigned char  State;
    	unsigned char *pWriteBuf;
    	
    	pWriteBuf = pBuf;	
    
    	Dummy     = NAND_ACCESS_START;
    
    	NAND_CMD      = NAND_CMD_READ_A;             // NAND б  
    	NAND_CMD      = NAND_CMD_WRITE_START;        // NAND ֱ  
    	NAND_ADDR     =                    0x00;      
    	NAND_ADDR     =  (PageNumber     & 0xFF);    // Page Address L
    	NAND_ADDR     = ((PageNumber>>8) & 0xFF);    // Page Address M   
    	if( NandDev->TotalSize >= 64*1024*1024 )     // Page Address H
    	{
        	NAND_ADDR = ((PageNumber>>16) & 0xFF);    
    	}
    	NAND_AddressSetupWait();
    
    	// 512 Ʈ  ִ´. 
    	for( Loop = 0; Loop < 512 ; Loop++ ) NAND_DATA = *pWriteBuf++;
    
    	NAND_CMD  = NAND_CMD_WRITE_RUN;                          // NAND ֱ  
    
    	while( 1 )
    	{
        	NAND_CMD  = NAND_CMD_READ_STATE;                         //   䱸 
    		State     = NAND_DATA & 0xFF;                        //  ¸ д´. 
    		if( ( State & NAND_STATUS_BUSY      ) != 0 ) break;  // Busy ̸  . 
    	}
    	Dummy = NAND_ACCESS_END;
    
    	if( ( State & NAND_STATUS_PROGRAM_OK ) == 0 ) return TRUE;
    	printf( "NAND Write  Fail\n" );
    
    	if( ( State & NAND_STATUS_PROTECTED  ) == 0 ) 
    	{
        	printf( "NAND Device Lock\n" );
    	}    

    	return FALSE;
}

//------------------------------------------------------------------------------
//  : Sector ε Page ε Ͽ  ´. 
// Ű : NandDev         : ÷   ּ 
//        PartitionNumber : Ƽ ȣ 
//        SectorNumber    :  ȣ 
// ȯ :  ȣ 
//  :  
//------------------------------------------------------------------------------
int 	NAND_GetPageFromSector( TNandInfo *NandDev, int SectorNumber )
{
    	int	VirBlock;	//  ǳʶ 
    	int 	RealBlock;	// 
    
    	RealBlock = SectorNumber / 32;
	VirBlock  = NandDev->VirBlock[RealBlock];
	
	if ( 0xffff == VirBlock ) return -1;

	return ( VirBlock*32 + (SectorNumber%32) );
}
//------------------------------------------------------------------------------
//  : NAND Sector Ÿ ִ´. 
// Ű : NandDev    : NAND 
//        PageNumber :    ȣ 
//        pBuf       : 512 Ʈ ũ  ּ 
// ȯ :  -1   0
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_WriteSector( TNandInfo *NandDev, int SectorNumber, unsigned char *pBuf )
{
    	int PageNumber;
    	int BlockNumber;
    
    	PageNumber = NAND_GetPageFromSector( NandDev, SectorNumber );
    	if( PageNumber < 0 ) return FALSE;
    
    	BlockNumber = PageNumber / 32;
    
    	//   üũ 
	/*
    	if( NandDev->pPartition[PartitionNumber].BaseBlock > BlockNumber ) return FALSE;
    	if( (  NandDev->pPartition[PartitionNumber].BaseBlock 
        	 + NandDev->pPartition[PartitionNumber].BlockCount ) <= BlockNumber ) return FALSE;
	*/

    	// Ÿ    Ѵ.    
    	return NAND_WritePage( NandDev, PageNumber, pBuf );
} 
//------------------------------------------------------------------------------
//  : NAND Sector д´. 
// Ű : NandDev    : NAND 
//        PageNumber :   ȣ 
//        pBuf       : 512 Ʈ ũ  ּ 
// ȯ :  
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_ReadSector( TNandInfo *NandDev, int SectorNumber, unsigned char *pBuf )
{
    	int PageNumber;
    	int BlockNumber;
    
    	PageNumber = NAND_GetPageFromSector( NandDev, SectorNumber );
		//pagenumber print out
    	if( PageNumber < 0 ) return FALSE;
    
    	BlockNumber = PageNumber / 32;
    
    	//   üũ 
	/*
    	if( NandDev->pPartition[PartitionNumber].BaseBlock > BlockNumber ) return FALSE;
    	if( (  NandDev->pPartition[PartitionNumber].BaseBlock 
        	 + NandDev->pPartition[PartitionNumber].BlockCount ) <= BlockNumber ) return FALSE;
	*/

    	NAND_ReadPage( NandDev, PageNumber, pBuf );
    	

    	return TRUE;
}

//------------------------------------------------------------------------------
//  : NAND Ѵ. 
// Ű : BaseAddress : NAND ÷ ̽ ּ 
//        NandDev     :  ÷   ּ 
//        
// ȯ :  FALSE  TRUE
//  :  
//------------------------------------------------------------------------------
BOOL 	NAND_DETECT( unsigned long BaseAddress , TNandInfo *NandDev )
{
    	unsigned char  MakerID, SizeID;
    	unsigned short Dummy;
    	//int            Loop;
    	//int            RestBlockCount;
    	
    	printf( "NAND Chip Check .......................\n" );
    	//printf( "  Base Address [%08X]\n", (unsigned int)BaseAddress );
    
    	NandDev->BaseAddress = BaseAddress;
  
    	Dummy     = NAND_ACCESS_START;
    	NAND_CMD  = NAND_CMD_READ_ID;                             // ID б 
    	NAND_ADDR = 0x00;                                         // ɾ  ΰ ൿ

    	MakerID   = NAND_DATA & 0xFF;                             //  б 
    	SizeID    = NAND_DATA & 0xFF;                             // ũ б 
    	Dummy     = NAND_ACCESS_END;
    
    	//printf( "  NAND Maker ID [%02X]  ", MakerID );
    	//printf( "  NAND Size  ID [%02X]\n", SizeID );		
    
    	NandDev->Type      = NAND_TYPE_UNKNOW;
    	switch( MakerID )
    	{
    	case 0xEC : 
                switch( SizeID )
                {
                case 0x73 : NandDev->Type = NAND_TYPE_SAMSUNG_16M ; 
                            NandDev->TotalSize =  16 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x75 : NandDev->Type = NAND_TYPE_SAMSUNG_32M ; 
                            NandDev->TotalSize =  32 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x76 : NandDev->Type = NAND_TYPE_SAMSUNG_64M ; 
                            NandDev->TotalSize =  64 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                case 0x79 : NandDev->Type = NAND_TYPE_SAMSUNG_128M; 
                            NandDev->TotalSize = 128 * 1024 * 1024; 
                            NandDev->EraseSize =  16 * 1024; 
                            break;
                }
                break;
    	} 
    
    	switch( NandDev->Type )
    	{
    	case NAND_TYPE_SAMSUNG_16M  : printf( "  Detect SAMSUNG [%02x:%02x] 16MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_32M  : printf( "  Detect SAMSUNG [%02x:%02x] 32MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_64M  : printf( "  Detect SAMSUNG [%02x:%02x] 64MByte\n",  MakerID, SizeID ); break;
    	case NAND_TYPE_SAMSUNG_128M : printf( "  Detect SAMSUNG [%02x:%02x] 128MByte\n", MakerID, SizeID ); break;
    	default                     : printf( "  Unknown Type\n"      ); break; 
    	}
    
    	if( NandDev->Type == NAND_TYPE_UNKNOW ) return FALSE;

    	// BAD  ĵ 
    	printf( "  BAD BLOCK SCAN ->" );
    	printf( "  Kernel, Ramdisk Bad Block [%d]\n", NAND_ScanBadBlock( NandDev ) );

    	return TRUE;
}
//------------------------------------------------------------------------------
//  : NAND-Flash  ã´.
//  : 
//------------------------------------------------------------------------------
int	NandFlash_Init( void )
{                           
	NAND_DETECT( NAND_BASE, &Nand1 ); // #define PXA_CS1_PHYS    0x04000000
									  //( PXA_CS1_PHYS+0x00000000 ) ,  TNandInfo       Nand1;
	return 0;
}

void nand_print_sector( int sector )
{
	char buf[512];
	//int i;
	memset( buf, 0, 512 );
	NAND_ReadSector( &Nand1, sector, buf );
	print_dump_memory( buf, 512, 16 );
}

