#include<arch/arch.h>
#include<migos_stdio.h>
#include<types.h>
#include<kernel/jvm.h>
#include<kernel/timer.h>
#include<kernel/schedule.h>
#include<arch/cpu.h>
#include<ffs.h>



unsigned int irq_sp;

extern void _timer_hand(void);
void isr_timer_interrupt(void);
void isr_touchscreen_interrupt(void);
void mk712_do_irq(void);
#if 0
void Irq_Handler(int32u irqno)
{
	switch ( 1 << (ffs(irqno) - 1)) {
		case BIT31:	// RTC Alarm Match Register Interrupt
			SerialOutputString("[31]\n");
			rtc_alarm_handler();
			break;
		case BIT30:	// RTC Hz Clock Tick Interrupt
			//SerialOutputString("[30]\n");
			rtc_handler();
			break;
		case BIT29:	// 
			SerialOutputString("[29]\n");
			break;
		case BIT28:	// 
			SerialOutputString("[28]\n");
			break;
		case BIT27:	// 
			SerialOutputString("[27]\n");
			break;
		case BIT26:	//OS_Timer0
			OSTimer0_IRQ();
			Kern_TickISR();
			//SerialOutputString("[26]\n");
			_Int_mask_clear();
			break;
		case BIT25:	// 
			SerialOutputString("[25]\n");
			break;
		case BIT24:	// 
			SerialOutputString("[24]\n");
			break;
		case BIT23:	// 
			SerialOutputString("[23]\n");
			break;
		case BIT22:	// 
			SerialOutputString("[22]\n");
			break;
		case BIT21:	// 
			SerialOutputString("[21]\n");
			break;
		case BIT20:	// 
			SerialOutputString("[20]\n");
			break;
		case BIT19:	// 
			SerialOutputString("[19]\n");
			break;
		case BIT18:	// 
			SerialOutputString("[18]\n");
			break;
		case BIT17:	// 
			SerialOutputString("[17]\n");
			break;
		case BIT16:	// 
			SerialOutputString("[16]\n");
			break;
		case BIT15:	// 
			SerialOutputString("[15]\n");
			break;
		case BIT14:	// 
			SerialOutputString("[14]\n");
			break;
		case BIT13:	// 
			SerialOutputString("[13]\n");
			break;
		case BIT12:	// 
			SerialOutputString("[12]\n");
			break;
		case BIT11:	// 
			SerialOutputString("[11]\n");
			break;
		case BIT10:	// 
			SerialOutputString("[10]\n");
			break;
		case BIT9:	// 
			SerialOutputString("[09]\n");
			break;
		case BIT8:	// 
			key_handler();
			break;
		case BIT7:	// 
			SerialOutputString("[07]\n");
			break;
		case BIT6:	// 
			SerialOutputString("[06]\n");
			break;
		case BIT5:	// 
			SerialOutputString("[05]\n");
			break;
		case BIT4:	// 
			SerialOutputString("[04]\n");
			break;
		case BIT3:	// 
			SerialOutputString("[03]\n");
			break;
		case BIT2:	// 
			SerialOutputString("[02]\n");
			break;
		case BIT1:	// 
			SerialOutputString("[01]\n");
			break;
		case BIT0:	// 
			SerialOutputString("[00]\n");
			break;
		default:
			SerialOutputHex(irqno);
			SerialOutputString("default!!\n");
			break;
	}
	//_nop_loop();
}
#endif

/*인터럽트 벡터 테이블 (irq예외 처리) */
fp_t int_vec[32] = {
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_touchscreen_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt,
		isr_timer_interrupt

};


				
				
				
/*************************************************************************** 
 * Function    : 
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/


void isr_dummy(void)
{
		kernel_printf("this is dummy interrupt \n");
}

void isr_common1(void)
{
		kernel_printf("this is common interrupt \n");
}



#include <arch/intgrt_struct.h>
extern struct irq irq0;
extern struct timer_struct timer1;
#define IRQEnableClear irq0.EnableClear
#define IRQEnableSet irq0.EnableSet
#define Timer1Clear timer1.Clear

void __irq isr_common(void)
{
		kernel_printf("\n\n %x \n", irq0.Status);
		IRQEnableSet = 0x0000002F;		//	Enable Timer1 IRQ (IRQs should still be disabled in the core.
		Timer1Clear = 0;
		printf("this is common interrupt \n");
		//_timer_hand();
}


extern struct timer_struct timer1;
#define Timer1Clear timer1.Clear

void irq_handler(unsigned int intnum)
{
		int vecnum = ffs(intnum);
		fp_t handler = int_vec[vecnum-1];
		handler();
		//_timer_hand();
//		IRQEnableSet = 0x0000002F;		//	Enable Timer1 IRQ (IRQs should still be disabled in the core.
}

#if 0
void context_sw(void)
{
		

}

#endif
/*Timer interrupt number = 20 */
void isr_timer_interrupt(void)
{
		reset_tick();
		update_timer();				/*update timer requests in the queue 'timer_queue' */
#if 1
		if(is_time_to_resched()){
//				kernel_printf("schedule!!\n");
				schedule();

		}
//		kernel_printf("timeslice = %d \n",get_current_thread()->timeslice);
#endif

		Timer1Clear = 0;
}

struct thread *touch_handler_thread;

#define MK712_GPIO			22

#if 0
void isr_touchscreen_interrupt(void)
{
		int cpu_sr;

		enter_critical_section();

		ICMR &= ~(1<<10);	/*Mask touchscreen interrupt */
		kernel_printf("touched!!!\n");
		wake_up_thread(touch_handler_thread);
		ICMR &= ~GPIO_bit(MK712_GPIO);
		GEDR(MK712_GPIO) |= GPIO_bit(MK712_GPIO);

		exit_critical_section();

}
#endif


void isr_touchscreen_interrupt(void)
{
		int cpu_sr;

		enter_critical_section();

		ICMR &= ~(1<<10);	/*Mask touchscreen interrupt */
		kernel_printf("touched!!!\n");
		mk712_do_irq();
		wake_up_thread(touch_handler_thread);
		GEDR(MK712_GPIO) |= GPIO_bit(MK712_GPIO);

		exit_critical_section();

}


//		mk712_do_irq,
//

