#include<arch/pxa255.h>
#include<migos_stdio.h>
#include<kernel/process.h>
#include<kernel/mm.h>
#include<kernel/shell.h>
#include<kernel/schedule.h>
#include<kernel/thread.h>
#include<kernel/timer.h>
#include<gui/gui.h>
#include<application.h>
#include<arch/cpu.h>
#include<dev/touch/touch.h>
#include<fs/romfs.h>
#include<list.h>
#include<string.h>

#if 0
extern memclt_t *pHeapListHead_g;
extern void task_key(void);
extern void task_home_network(void);
extern void task_coffee_maker(void);
int32u GetThreadMemInfo(tcb_t *thread);
int32u GetFreeMemInfo(void);
#endif

char argv[30][30] = {0, };
int argc;


void print_threadcontrol_usage(void);
static int ls_fs( int argc, char argv[][30]);
static int cd_fs( int argc, char argv[][30]);

void print_javacommand_usage(void)
{
		kernel_printf("Usage : javacommand [operation] [args1]...\n");
		kernel_printf("Java Command List\n");
		kernel_printf("============================================================\n");
		kernel_printf("run - Run a java application\n");
		kernel_printf("kill - Kill a java application\n");
		kernel_printf("sleep - sleep specific java thread\n");
		kernel_printf("status - show java threads' status running currently\n");
		kernel_printf("applist - show java application list that can be executed\n");
}


fatfs_path mshell_cur_path;



static int md_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	kernel_printf("argv : %s \n", argv[1]);
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: cd: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;

	{
	char fpath[255];
	memset( fpath, 0 , 255);
	strcpy( fpath, cur_path->FullPath );
	strcat( fpath, argv[1] );
	kernel_printf("temp :%s \n", fpath);

	if( fatfs_create_directory( &g_fatfs, fpath ) == 0 )
	{
		kernel_printf("\r\n-mshell: mkdir: %s: Can't make directory.\r\n", argv[1] );
	}

	}
	return 0;
}

static int rmdir_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: rmdir: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;
	{
	char fpath[255];
	memset( fpath, 0 , 255);
	strcpy( fpath, cur_path->FullPath );
	strcat( fpath, argv[1] );

	if( fatfs_delete_directory( &g_fatfs, fpath ) == 0 )
	{
		kernel_printf("\r\n-mshell: rmdir: %s: Can't remove directory.\r\n", argv[1] );
	}

	}
	return 0;
}

static int rm_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	if( g_fatfs.type == FS_UNKNOWN )
	{
		printf("\r\nmshell: rm: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;
	{
	char fpath[255];
	memset( fpath, 0 , 255);
	strcpy( fpath, cur_path->FullPath );
	strcat( fpath, argv[1] );
	if( fatfs_delete_file( &g_fatfs, fpath ) == 0 )
	{
		kernel_printf("\r\n-mshell: rm: %s: Can't remove directory.\r\n", argv[1] );
	}
	}

	return 0;
}

static int mv_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: mv: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 3 )
		return 0;
	{
	char fpath[255],fpath2[255];
	memset( fpath, 0 , 255);
	strcpy( fpath, cur_path->FullPath );
	strcat( fpath, argv[1] );
	memset( fpath2, 0, 255);
	strcpy( fpath2, cur_path->FullPath );
	strcat( fpath2, argv[2] );

	if( fatfs_rename_directory( &g_fatfs, fpath, fpath2 ) == 0 )
	{
		kernel_printf("\r\n-mshell: mv: %s: Can't remove directory.\r\n", argv[1] );
	}
	}

	return 0;
}

static int pwd_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;	

	kernel_printf("\r\n%s", cur_path->FullPath );
}
int java_command(int argc, char argv[][30])
{ 
		int ret = 0;


#if 1
		if(!strcmp(argv[1],"run")){ 
				if(argc > 2){
						ret = java_command_run(argv[2]);
				}else {
						kernel_printf("Missing argument\n");
						ret = -EINVARG;
				}

		} else if(!strcmp(argv[1],"kill")){ 
				if(argc > 2){
						int id = strtoul(argv[2],NULL,0);
						ret = java_command_kill(id);
				}else {
						kernel_printf("Invalid argument %s\n",argv[2]);
						ret = -EINVARG;
				}

		} else if(!strcmp(argv[1],"sleep")){ 
				if(argc > 2){
						int id = strtoul(argv[2],NULL,0);
						ret= java_command_sleep(id);
				}else {
						kernel_printf("Invalid argument %s\n",argv[2]);
						ret = -EINVARG;
				}

		} else if(!strcmp(argv[1],"status")){ 
				ret = java_command_status();

		} else if(!strcmp(argv[1],"applist")){ 
				ret = java_command_applist();

		} else {
				print_javacommand_usage();
				ret = SUCCESS;
		}


ret_from_command:

		return ret;
#endif

}


static int cat_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	fatfs_file file;	
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: cat: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		kernel_printf("\r\n[FS] %s is invalid path...\r\n", cur_path->FullPath );
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;

	if( fatfs_open_path( &g_fatfs, argv[1], &path ) == 0 )
	{
		kernel_printf("\r\n-mshell: cat: %s: There isn't file.\r\n", argv[1] ); 
	}
	else
	if( path.Attr & FILE_ATTR_DIRECTORY )
	{
		kernel_printf("\r\n-mshell: cat: %s: This is not file.\r\n", path.FileName );
	}
	else
	{
		// cat operation
		if( fatfs_fopen( &g_fatfs, path.FullPath, &file ) == 0 )
		{
			kernel_printf("\r\n-mshell: cat: %s: Can't open file.\r\n", path.FullPath );
		}
		else
		{
			char buf[512];
			int readed = 1;
			kernel_printf("\r\n");
			
			while( readed )
			{
				readed = fatfs_fread( &g_fatfs, &file, buf, sizeof(buf) );
				buf[readed] = '\0';
				kernel_printf("%s", buf );
			}
		}
	}	
	return 0;
}





int shell(void)
{
		char buff[100] = { 0, };
		struct command *p_command=NULL;

	if( g_fatfs.type != FS_UNKNOWN )
	{
		kernel_printf("mshell: open_path\r\n");
		fatfs_open_path( &g_fatfs, "/", 
			&mshell_cur_path );	
	}



		while(1) {
				kernel_printf("shell> ");
				p_command = get_instruction(buff);


				if(p_command){
						p_command->fp(argc,argv);

				}
		}
}




static int ls_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;

	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: ls: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		kernel_printf("\r\n[FS] %s is invalid path...\r\n", cur_path->FullPath );
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	
	kernel_printf("\r\n");
	while( path.de )
	{
		char mb[20]={0,};
		if( path.de == 0 ) break;	
		if( path.Attr & FILE_ATTR_DIRECTORY )
			kernel_printf("<DIR> %13s\r\n", path.FileName );	
		else
		{
			itomb( path.FileSize, mb );
			kernel_printf("      %13s %10s\r\n", path.FileName, mb );
		}
		fatfs_path_next( &g_fatfs, &path );
	}	
	return 0;
}

static int cd_fs( int argc, char argv[][30] )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: cd: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;
	if( fatfs_open_path( &g_fatfs, argv[1], &path ) )
	{
		if( path.Attr & FILE_ATTR_DIRECTORY )
		{
			fatfs_open_path( &g_fatfs, argv[1], cur_path );
		}
		else
		{
			kernel_printf("\r\n-mshell: cd: %s: This is not directory.\r\n", path.FileName );
		}
	}
	else
	{
		kernel_printf("\r\n-mshell: cd: %s: There isn't file ore directory.\r\n", argv[1] ); 
	}	
	return 0;
}




int java_command_run(char *program)
{
		if(!is_appclass_exist(program)){
				kernel_printf("Error: %s application class doesn't exist\n");
				return FAILED;
		}

		kernel_printf("Creating java application process......\n");
		if(create_jvm_process(1, program, 0) == NULL){
				kernel_printf("Error: Cannot create java process\n");
				return FAILED;
		}

		return SUCCESS;

}

int java_command_kill(int id)
{
		struct process *iter = NULL;
#if 0
		list_for_each_entry(iter,iter->thread_list){
		}
#endif

}

int java_command_sleep(int id)
{
		;

}



int java_command_status(void)
{
		struct thread *iter = NULL;

		kernel_printf("\n Java Thread Status\n");
		kernel_printf("======================================\n");
		kernel_printf("ID  Name            State      Parent \n");
		kernel_printf("======================================\n");

		list_for_each_entry(iter,&get_rq()->rdy_list,rdy_list){
				if(iter->thread_type == JAVA_THREAD){
						kernel_printf("%4d   %-15s       %-10d   %-15s\n",iter->thread_id, 
										iter->name,iter->state, iter->parent_proc->name);
				}
		}list_end_for;

		list_for_each_entry(iter,&get_waitq()->wait_list,wait_list){
				if(iter->thread_type == JAVA_THREAD){
						kernel_printf("%4d   %-15s       %-10d   %-15s\n",iter->thread_id, 
										iter->name,iter->state, iter->parent_proc->name);
				}
		}list_end_for;
}



int java_command_applist(void)
{
		int i = 0;

		kernel_printf("\nRegistered Java Application List\n");
		kernel_printf("==================================\n");

		for(i = 0; i < ac_count_g; i++ ){
				kernel_printf("%d : %s \n",i,act_g[i].name);
		}

		kernel_printf("==================================\n");

}

void thread_test(int argc, char argv[][30])
{ 
		kernel_printf("thread test\n");

}

#if 1
void
top(int argc, char argv[][30])
{
		int cpu_sr;
		struct process *iter = NULL;
		int32u nblocks;


		kernel_printf("Thread Status\n");
		kernel_printf("-------------------------------------------------\n");
		kernel_printf("  Id      Name              Mem(block)   Mem(%)  \n");
		kernel_printf("-------------------------------------------------\n");

		enter_critical_section();	
		list_for_each_entry(iter,&(get_process_list_head()->proc_list),proc_list){
				struct mm_clt *mm_head = NULL;
				mm_head = get_process_mm_info(iter);
				nblocks = get_alloc_mem_info(mm_head);
				
				
				kernel_printf("%4d    %-15s       %-10d   %-10d\n",
								iter->process_id,
								iter->name,  
								nblocks,
								nblocks / NUM_OF_BLOCKS * 100);


				
		}list_end_for;
		exit_critical_section();
		/*Show Memory status */


		kernel_printf("-------------------------------------------------\n");
		kernel_printf("Free blocks : %d \n", get_free_mem_info());



		return;
}

#endif

void ps(int argc, char argv[][30])
{ 
		struct thread *iter = NULL;
		struct process *iter_proc = NULL;
	//	get_current_thread()

		kernel_printf("Process Status\n");
		kernel_printf("=========================================================\n");
		kernel_printf("ID  Name                                  Num_Thread \n");
		kernel_printf("=========================================================\n");
		list_for_each_entry(iter_proc,&get_process_list_head()->proc_list,proc_list){
				kernel_printf("%4d   %-15s       %-5d   %-5d   %-5d\n",iter_proc->process_id, iter_proc->name,
								iter_proc->process_type, iter_proc->state, iter_proc->alive_thread_count);
		}list_end_for;


		kernel_printf("\n\n\n");

		kernel_printf("\n Thread Status\n");
		kernel_printf("===========================================================================\n");
		kernel_printf("ID  Name                Type         State        Parent     Emergency\n");
		kernel_printf("===========================================================================\n");

		list_for_each_entry(iter,&get_rt_rq()->rdy_list,rdy_list){
				kernel_printf("%4d   %-15s       %-5d   %-5d   %-15s %-5d\n",iter->thread_id, iter->name,
								iter->thread_type, iter->state, iter->parent_proc->name, iter->rt_fact);
		}list_end_for;

		list_for_each_entry(iter,&get_rq()->rdy_list,rdy_list){
				kernel_printf("%4d   %-15s       %-5d   %-5d   %-15s %-5d\n",iter->thread_id, iter->name,
								iter->thread_type, iter->state, iter->parent_proc->name, iter->rt_fact);
		}list_end_for;

		list_for_each_entry(iter,&get_waitq()->wait_list,wait_list){
				kernel_printf("%4d   %-15s       %-5d   %-5d   %-15s %-5d\n",iter->thread_id, iter->name,
								iter->thread_type, iter->state, iter->parent_proc->name, iter->rt_fact);
		}list_end_for;
#if 0
		list_for_each_entry(){


		}list_end_for;
#endif

}

#define MK712_GPIO			22

int get_touch()
{
	int x, y, status;
	int cpu_sr;
	
	wait_thread(get_current_thread());

	while(1)
	{

			if( touch_get_event( &x, &y, &status ) )
			{
					if( status == MK712_STATUS_DOWN )
					{
							//kernel_printf("DOWN\n");
							gui_mouse_event_lb_down( x, y );
					}
					else if( status == MK712_STATUS_UP )
					{
							//kernel_printf("UP\n");
							gui_mouse_event_lb_up( x, y );
					}
			}
		enter_critical_section();
		ICMR |= (1<<10);
		ICMR &= ~GPIO_bit(MK712_GPIO);
		wait_thread(get_current_thread());
		exit_critical_section();
	}
	return 0;
}


void msg_handler(void)
{
		msg m;

		while( get_message( &m, 0 ) )
		{
				//check_touch();
				dispatch_message( &m );
				//usleep(30);
		}
}

void touchtest(int argc, char argv[][30])
{

		kernel_printf("Touch Test\n");
		setup_touch();

		create_kernel_thread(5, "get_touch", get_touch, NORMAL, 0);
		sleep(2);
		create_kernel_thread(6, "msg handler", msg_handler, NORMAL, 0);

}



#include<arch/ez_x5.h>
int thread_control(int argc, char argv[][30])
{ 
		kernel_printf("thread control\n");
		int ret = 0;


#if 1
		if(!strcmp(argv[1],"kill")){ 
				if(argc > 2){
						int id = __strtou(argv[2],NULL,0);
						ret = kill(id);
				}else {
						kernel_printf("Invalid argument %s\n",argv[2]);
						ret = -EINVARG;
				}

		} else if(!strcmp(argv[1],"sleep")){ 
				if(argc > 3){
						int cpu_sr;
						unsigned int id = __strtou(argv[2],NULL,0);
						unsigned int time = __strtou(argv[3],NULL,0);
						struct thread *t = find_thread_by_id(id);
						if(t){
								led_on(_LED_3);
								sleep_thread(t,time);
								led_off();

						}else {
								kernel_printf("No such thread exist\n");
						}
						
						
				}else {
						kernel_printf("Invalid argument %s\n",argv[2]);
						ret = -EINVARG;
				}

		} else if(!strcmp(argv[1],"block")){ 
				unsigned int id = __strtou(argv[2],NULL,0);
				struct thread *t = find_thread_by_id(id);
				if(t){
						wait_thread(t);
						kernel_printf("wait thread \n");
				}else {
						kernel_printf("No such thread exist\n");
				}

		} else if(!strcmp(argv[1],"wakeup")){ 
				int id = __strtou(argv[2],NULL,0);
				struct thread *t = find_thread_by_id(id);
				if(t){
						wake_up_thread(t);
				}else {
						kernel_printf("No such thread exist\n");
				}

		} else {
				print_threadcontrol_usage();
				ret = SUCCESS;
		}


ret_from_command:

		return ret;
#endif

}



void help(int argc, char argv[][30])
{ 
		kernel_printf("Help\n");
		kernel_printf("============================================================\n");
		kernel_printf(" javacommand      - Run a java application\n");
		kernel_printf(" threadtest       - Kill a java application\n");
		kernel_printf(" threadcontrol    - Sleep specific java thread\n");
		kernel_printf(" ps               - Show java threads' status running currently\n");
		kernel_printf(" top              - Show java application list that can be executed\n");
		kernel_printf(" touchtest        - Test touch screen\n");
}

static struct command command_list[NUM_COMMAND_LIST] = {
		{"javacommand", java_command},
		{"thread_test", thread_test},
		{"ps", ps},
		{"top", top},
		{"threadcontrol", thread_control},
		{"touchtest", touchtest},
		{"yield", yield_thread},
		{"cd", cd_fs},
		{"ls", ls_fs},
		{"mkdir", md_fs},
		{"rmdir", rmdir_fs},
		{"md", md_fs},
		{"mv", mv_fs},
		{"pwd", pwd_fs},
		{"cat", cat_fs},
		{"help", help}
};



#if 0

void
fork()
{
		/*Run Demo program */
		printf("Enter program name : ");

		/*Kern_ThreadCreate(..,program,..); */
		char *program = get_one_token();
		printf("RUN %s\n", program);
		if(!strcmp(program,"demo")){
				Kern_ThreadCreate(2,"key task", &task_key, 2, 0);
				Kern_ThreadCreate(3,"home network", &task_home_network, 3, 0);
				Kern_ThreadCreate(4,"coffee maker", &task_coffee_maker, 4, 0);
		}else{
				printf("%s doesn't exist\n");
		}
		return;
}

void
ps()
{
		/*Show Threads status */

		printf("Thread Status\n");
		printf("--------------------------------------\n");
		printf("  Id      Name               Status\n");
		printf("--------------------------------------\n");

		printf("%4d    %-15s       %-10s\n",
						initThread.tid,	
						initThread.name,  
						DecToStatus(initThread.status));

		CRITICAL_SECTION_ENTER();	
		tcb_t *iter;
		ListForEachEntry(iter,ReadyListHead(),threadList){
				printf("%4d    %-15s       %-10s\n",
								iter->tid,	
								iter->name,  
								DecToStatus(iter->status));
		}
		CRITICAL_SECTION_LEAVE();

		return;
}

#endif

static char *status_str[6] = {
		"CREATED",
		"IDLE",
		"READY",
		"RUNNING",
		"FINISHED",
		"FREE" 
};
#if 0
char *
DecToStatus(tcb_status status)
{
		return status_str[status];
}

#endif
int test_led=0;
#include<dev/led/led.h>


#if 0
static int ed_fs( int argc, char** argv )
{
	fatfs_path* cur_path = &mshell_cur_path;
	fatfs_path path;
	fatfs_file file;	
	if( g_fatfs.type == FS_UNKNOWN )
	{
		kernel_printf("\r\nmshell: ed: filesystem is not mounted.\r\n");
		return 0;
	}

	if( fatfs_open_path( &g_fatfs, cur_path->FullPath, &path ) == 0 )
	{
		kernel_printf("\r\n[FS] %s is invalid path...\r\n", cur_path->FullPath );
		fatfs_open_path( &g_fatfs, "/", cur_path );
		fatfs_open_path( &g_fatfs, "/", &path );
	}	
	if( argc < 2 )
		return 0;

	
	if( fatfs_open_path( &g_fatfs, argv[1], &path ) )
	{
		kernel_printf("\r\n-mshell: ed: %s: There already are exist.\r\n", argv[1] ); 
		return 0;
	}

	{
	char filebuf[2000];
	char* cur;
	int len = 0, left =0;
	int c;
	fatfs_file file;
	char fpath[255];
	memset( fpath, 0 , 255);
	strcpy( fpath, cur_path->FullPath );
	strcat( fpath, argv[1] );
	
	kernel_printf("\r\n file path : [%s]\r\n If edit is end, press 'Ctrl+Z' ...\r\n", fpath );

	if( fatfs_create_file( &g_fatfs, fpath ) == 0 )
	{
		kernel_printf("\r\n-mshell: ed: %s: Can't create file.\r\n", argv[1] );
		return 0;
	}

	
	if( fatfs_fopen( &g_fatfs, fpath, &file ) == 0 )
	{
		kernel_printf("\r\n-mshell: ed: %s: Can't Open file.\r\n", argv[1] );
		return 0;
	}
	
	
	// editor
	memset( filebuf, 0, 2000 );
	cur = filebuf;
	while(1)
	{
		c = getc();
		if( c == 0x1a ) // ^Z
			break;
		if( c == BS )
		{
			if( filebuf != cur )
			{
				len--;
				*cur-- = ' ';
				kernel_printf("\b \b");
			}
		}
		else if( c == CR ) // enter
		{
			len+=2;
			*cur++ = c;
			*cur++ = LF;
			kernel_printf("\r\n");
		}
		else if( c == 0x1b ) // ??
		{
			len+=3;
			*cur++ = c;
			*cur++ = getc();
			*cur++ = getc();
		}
		else
		{
			len++;
			*cur++ = c;
			printf("%c",c);
		}
	}
	*cur = '\0';
	len++;
	left = len;

	cur = filebuf;
	while( left > 0 )
	{
		c = fatfs_fwrite( &g_fatfs, &file, cur, left ); 
		cur += c;
		left -= c;
	}

	fatfs_fclose( &g_fatfs, &file );

	printf("\r\n[%s] %d Bytes written...\r\n", argv[1], len );

	}
	return 1;
}
#endif





struct command *
get_instruction(char *buff)
{
		char ret = 0;
		int i = 0;

		int num = kernel_gets(buff);
		char *command_name = get_command(buff);


		while(i < MAX_COMMAND_LENGTH){
				if(!strcmp(command_name, command_list[i].command_name)){
						return &command_list[i];
				}
				i++;
		}

		return NULL;

}


char *get_command(char *buff)
{
		int i = 0;
		int buff_count = 0;
		int word_count = 0;
		argc = 0;
		memset(argv,0,sizeof(argv));

		while(buff_count < 100){
				if(buff[i] == NULL){
						if(i !=0){
								strncpy(argv[argc],buff,i+1);
								argv[argc][i+1] = NULL;
								argc++;
								word_count++;
						}
						break;
				}

				if(buff[i] == ' '){
						strncpy(argv[argc],buff,i);
						argv[argc][i] = NULL;
						buff += (i+1);
						argc++;
						i = 0;
						buff_count++;
						word_count++;
						continue;

				}			
				i++;
				buff_count++;

		}
//		SerialInputString(buffer,20);
		//sscanf("%s",buffer);
		if(word_count == 0){
				return NULL;
		}else {
				return argv[0];
		}
}

void print_threadcontrol_usage(void)
{
		kernel_printf("\nThread Control Commands List\n");
		kernel_printf("====================================\n");
		kernel_printf("sleep [thread id]\n");
		kernel_printf("kill [thread id]\n");
		kernel_printf("block [thread id]\n");
		kernel_printf("wakeup [thread id]\n");
		kernel_printf("help \n");

}

#if 0
void
show_help(void)
{
		printf("\nCommands List\n");
		printf("--------------------\n");
		printf("run [program name]\n");
		printf("kill [thread id]\n");
		printf("ps \n");
		printf("top [thread id]\n");
		printf("help \n");
		printf("--------------------\n\n");


}

#endif
