#include<migos_stdio.h>

#include<types.h>
#include<kernel/process.h>





/******************************************************************************
 * VFS Test Routine
 * An user can learn how to manage the virtual file system through the following
 * and also know the process registering a new device that user willing to use.
 *
 * by Joongyu Sun
 * ***************************************************************************/
#include<kernel/vfs.h>
#include<kernel/resource.h>

void dummy_f(void);
int dummy_open(struct file*,char *name, int mode);
int dummy_read(struct file *,char *,int);


struct file_op dummy_ops = {
		.init = dummy_f,
		.open = dummy_open,
		.read = dummy_read
};

struct resource dummy = {
		.type = TYPE_FS,
		.name = "dummy",
		.private = &dummy_ops,
		.belongs_to = NULL
};


extern struct vfs_object **vfile_table;



void vfs_test_routine(void)
{
	init_vfs();
	int result = vfs_register_device(1 , (struct resource *)&dummy);

	kernel_printf("First operator address : %x \n", vfile_table[TYPE_FS]);

	int fd = open(TYPE_FS,"test",0);
	int fd1 = open(TYPE_FS,"test1",0);
	int fd2 = open(TYPE_FS,"test2",0);

	struct file *iter = NULL;

	char test11[100] = { 0, };

	int nn = read(fd2, test11, 10);
	kernel_printf("num of read char : %d \n", nn);


	int nnn;
//	sscanf("%d ", &nnn);

	list_for_each_entry(iter, &current_process->file_table.file_list, file_list){
			kernel_printf("file : %d \n",iter->fd);
	}list_end_for;




}

void dummy_f(void)
{
		kernel_printf("This is dummy initializing operator!!!\n");
}

int dummy_open(struct file *this_file,char *name, int mode )
{
		kernel_printf("This is dummy open !!!\n");
		return 1;
}

int dummy_read(struct file *this_file,char *buffer, int size)
{
		kernel_printf("This is dummy read!!!\n");
		return 10;
}

/*
 *                                          VFS test routine until this line
 * ***************************************************************************/











/******************************************************************************
 * Kernel Memory Management Test Routines
 * A user can learn how to manage the kernel memory which MIGOS provide to user.
 *
 * by Joongyu Sun
 * ***************************************************************************/
#include<kernel/mm.h>
#include<list.h>


void kmem_test_routine(void)
{
		struct mm_clt *iter = NULL;
		kmem_init();

		unsigned int *a1 = k_malloc(10);
		unsigned int *a2 = k_malloc(100);
		unsigned int *a3 = k_malloc(1000);
		unsigned int *a4 = k_malloc(10000);
		unsigned int *a5 = k_malloc(100000);

		k_free(a4);
		k_free(a2);
		k_free(a1);
		k_free(a3);
		k_free(a5);

		a4 = k_malloc(100);
		a5 = k_malloc(1000);


	list_for_each_entry(iter, &pHeapListHead_g->memLink, memLink){
			kernel_printf("memLink\n");

			kernel_printf("iter nblocks : %d \n", iter->nblocks);
	}list_end_for;

	list_for_each_entry(iter, &pHeapListHead_g->allocLink, allocLink){
			kernel_printf("allocLink\n");
			kernel_printf("iter nblocks : %d \n", iter->nblocks);
	}list_end_for;

	list_for_each_entry(iter, &pHeapListHead_g->freeMemLink, freeMemLink){
			kernel_printf("freeMemLink\n");
			kernel_printf("iter nblocks : %d \n", iter->nblocks);
	}list_end_for;
}







/*
 *                       Kernel memory management test routines until this line
 * ***************************************************************************/
