#include <kni.h>
#include <stdio.h>
#include<kernel/mm.h>
#include <win32app_export.h>

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawLine()
{
    int y2 = KNI_GetParameterAsInt(4);
    int x2 = KNI_GetParameterAsInt(3);
    int y1 = KNI_GetParameterAsInt(2);
    int x1 = KNI_GetParameterAsInt(1);

	Graphics_drawLine(x1,y1,x2,y2);

    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_fillRect()
{
    int height = KNI_GetParameterAsInt(4);
    int width = KNI_GetParameterAsInt(3);
    int y = KNI_GetParameterAsInt(2);
    int x = KNI_GetParameterAsInt(1);

	Graphics_fillRect(x,y,width,height);

    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawRect()
{
    int height = KNI_GetParameterAsInt(4);
    int width = KNI_GetParameterAsInt(3);
    int y = KNI_GetParameterAsInt(2);
    int x = KNI_GetParameterAsInt(1);

	Graphics_drawRect(x,y,width,height);

    KNI_ReturnVoid();
}


KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawRoundRect()
{
	int arcHeight = KNI_GetParameterAsInt(6);
	int arcWidth = KNI_GetParameterAsInt(5); 
    int height = KNI_GetParameterAsInt(4);
    int width = KNI_GetParameterAsInt(3);
    int y = KNI_GetParameterAsInt(2);
    int x = KNI_GetParameterAsInt(1);

	Graphics_drawRoundRect(x,y,width,height,arcWidth,arcHeight);

    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_fillRoundRect()
{
	int arcHeight = KNI_GetParameterAsInt(6);
	int arcWidth = KNI_GetParameterAsInt(5); 
    int height = KNI_GetParameterAsInt(4);
    int width = KNI_GetParameterAsInt(3);
    int y = KNI_GetParameterAsInt(2);
    int x = KNI_GetParameterAsInt(1);

	Graphics_fillRoundRect(x,y,width,height,arcWidth,arcHeight);

    KNI_ReturnVoid();
}


KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawString()
{
    int anchor = KNI_GetParameterAsInt(4);
    int      y = KNI_GetParameterAsInt(3);
    int      x = KNI_GetParameterAsInt(2);

	char *string;
	jchar *buffer;
	int size;
	int i;

    KNI_StartHandles(1); 
    KNI_DeclareHandle(stringHandle); 
    KNI_GetParameterAsObject(1, stringHandle); 

    size = KNI_GetStringLength(stringHandle); 

	buffer = (jchar*)k_malloc(sizeof(jchar)*size);
	string = (char*)k_malloc(sizeof(char)*size);

    KNI_GetStringRegion(stringHandle, 0, size, buffer); 

	
	for(i=0;i<size;i++)
	{
		string[i] = (char) buffer[i];
	}

	string[size] = '\0';

	Graphics_drawString(string, x, y, anchor);

    KNI_EndHandles();
    KNI_ReturnVoid();
}

//  Լ
KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_getPixel()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_getDisplayColor()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawRGB()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_doCopyArea()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_fillTriangle()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawChars()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawChar()
{
	    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawSubstring()
{
	    KNI_ReturnVoid();
}


KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_drawArc()
{
	    KNI_ReturnVoid();
}


KNIEXPORT KNI_RETURNTYPE_VOID Java_javax_microedition_lcdui_Graphics_fillArc()
{
	    KNI_ReturnVoid();
}


