// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package com.sun.cldc.isolate;

import com.sun.cldchi.jvm.JVM;
import java.io.PrintStream;

// Referenced classes of package com.sun.cldc.isolate:
//            IsolateStartupException, IsolateResourceError, IllegalIsolateStateException

public final class Isolate
{

    public Isolate(String s, String as[])
        throws IsolateStartupException
    {
        this(s, as, (String[])null);
    }

    public Isolate(String s, String as[], String as1[])
        throws IsolateStartupException
    {
        this(s, as, as1, (String[])null);
    }

    public Isolate(String s, String as[], String as1[], String as2[])
        throws IsolateStartupException
    {
        _memoryReserve = 0;
        _memoryLimit = 0x7fffffff;
        _APIAccess = 0;
        _ConnectDebugger = 0;
        _UseVerifier = 1;
        _profileId = -1;
        securityCheck();
        if(s == null)
            throw new IllegalArgumentException("specified class name is null");
        registerNewIsolate();
        _priority = 2;
        _mainClass = s;
        _mainArgs = argCopy(as);
        _app_classpath = argCopy(as1);
        _sys_classpath = argCopy(as2);
        if(_sys_classpath.length != 0)
        {
            System.err.println();
            System.err.println("****warning****");
            System.err.println("****Untrusted user classes must never be put");
            System.err.println("****on the system class path");
            System.err.println("****warning****");
            System.err.println();
        }
    }

    public synchronized void start()
        throws IsolateStartupException
    {
        if(getStatus() > 1)
            throw new IsolateStartupException("Isolate has already started");
        try
        {
            nativeStart();
        }
        catch(IsolateResourceError isolateresourceerror)
        {
            throw isolateresourceerror;
        }
        catch(OutOfMemoryError outofmemoryerror)
        {
            throw outofmemoryerror;
        }
        catch(Throwable throwable) { }
        while(getStatus() <= 1) 
            try
            {
                waitStatus(1);
            }
            catch(InterruptedException interruptedexception)
            {
                throw new IsolateStartupException("Exception was thrown while Isolate was starting");
            }
    }

    public void exit(int i)
    {
        try
        {
            stop(i, this != currentIsolate() ? 4 : 2);
        }
        catch(SecurityException securityexception)
        {
            stop(i, 2);
        }
    }

    public void halt(int i)
    {
        try
        {
            stop(i, this != currentIsolate() ? 5 : 3);
        }
        catch(SecurityException securityexception)
        {
            stop(i, 3);
        }
    }

    public boolean isTerminated()
    {
        int i = getStatus();
        return i >= 4;
    }

    public static Isolate currentIsolate()
    {
        securityCheck();
        return currentIsolate0();
    }

    private static native Isolate currentIsolate0();

    public static Isolate[] getIsolates()
    {
        securityCheck();
        return getIsolates0();
    }

    private static native Isolate[] getIsolates0();

    public int id()
    {
        return id0();
    }

    private native int id0();

    public int reservedMemory()
    {
        return _memoryReserve;
    }

    public int totalMemory()
    {
        return _memoryLimit;
    }

    public int usedMemory()
    {
        return usedMemory0();
    }

    private native int usedMemory0();

    public void setMemoryQuota(int i)
    {
        setMemoryQuota(i, i);
    }

    public void setMemoryQuota(int i, int j)
    {
        if(i < 0 || i > j)
        {
            throw new IllegalArgumentException();
        } else
        {
            _memoryReserve = i;
            _memoryLimit = j;
            return;
        }
    }

    synchronized boolean isStarted()
    {
        return getStatus() <= 1;
    }

    private String[] argCopy(String as[])
    {
        if(as == null)
        {
            return new String[0];
        } else
        {
            String as1[] = new String[as.length];
            JVM.unchecked_obj_arraycopy(as, 0, as1, 0, as.length);
            return as1;
        }
    }

    private native void registerNewIsolate();

    private native void stop(int i, int j);

    public void setPriority(int i)
    {
        if(i >= 1 && i <= 3)
        {
            _priority = i;
            setPriority0(i);
        }
    }

    private native void setPriority0(int i);

    public int getPriority()
    {
        return _priority;
    }

    public boolean isSuspended()
    {
        return isSuspended0() != 0;
    }

    private native int isSuspended0();

    public void suspend()
    {
        suspend0();
    }

    private native void suspend0();

    public void resume()
    {
        resume0();
    }

    private native void resume0();

    public int exitCode()
    {
        return exitCode0();
    }

    private native int exitCode0();

    public synchronized void waitForExit()
    {
        while(getStatus() <= 3) 
            try
            {
                waitStatus(3);
            }
            catch(InterruptedException interruptedexception)
            {
                throw new Error();
            }
    }

    public String[] getClassPath()
    {
        return argCopy(_app_classpath);
    }

    private static void securityCheck()
    {
        if(_API_access_ok == 0)
            throw new SecurityException("Access to Isolate API not allowed");
        else
            return;
    }

    public void setAPIAccess(boolean flag)
    {
        _APIAccess = !flag ? 0 : 1;
        if(!flag && equals(currentIsolate()))
            _API_access_ok = 0;
    }

    public void setDebug(boolean flag)
    {
        _ConnectDebugger = !flag ? 0 : 1;
    }

    public void attachDebugger()
    {
        securityCheck();
        attachDebugger0(this);
    }

    public void setUseVerifier(boolean flag)
    {
        _UseVerifier = !flag ? 0 : 1;
    }

    private native int getStatus();

    private native void notifyStatus();

    private native void waitStatus(int i)
        throws InterruptedException;

    private native void nativeStart()
        throws IsolateStartupException;

    public native void setProfile(String s)
        throws IllegalArgumentException, IllegalIsolateStateException;

    public void setHiddenPackages(String as[])
        throws IllegalIsolateStateException
    {
        if(getStatus() > 1)
        {
            throw new IllegalIsolateStateException("Can only set hidden packages before Isolate starts");
        } else
        {
            _hidden_packages = as;
            return;
        }
    }

    public void setRestrictedPackages(String as[])
        throws IllegalIsolateStateException
    {
        if(getStatus() > 1)
        {
            throw new IllegalIsolateStateException("Can only set restricted packages before Isolate starts");
        } else
        {
            _restricted_packages = as;
            return;
        }
    }

    private native void attachDebugger0(Isolate isolate);

    private static int _API_access_ok;
    private int _priority;
    private Isolate _next;
    private long _uniqueId;
    private int _terminated;
    private int _saved_exit_code;
    private String _mainClass;
    private String _mainArgs[];
    private String _app_classpath[];
    private String _sys_classpath[];
    private String _hidden_packages[];
    private String _restricted_packages[];
    private int _memoryReserve;
    private int _memoryLimit;
    private int _APIAccess;
    private int _ConnectDebugger;
    private int _UseVerifier;
    private int _profileId;
    private static final int DEFAULT_PROFILE_ID = -1;
    private static final int SUSPEND = 0;
    public static final int MIN_PRIORITY = 1;
    public static final int NORM_PRIORITY = 2;
    public static final int MAX_PRIORITY = 3;
    static final int INVALID_TASK_ID = -1;
    static final int NEW = 1;
    static final int STARTED = 2;
    static final int STOPPING = 3;
    static final int STOPPED = 4;
    private static final int EXIT_REASON_IMPLICIT_EXIT = 1;
    private static final int EXIT_REASON_UNCAUGHT_EXCEPT = 6;
    private static final int EXIT_REASON_SELF_EXIT = 2;
    private static final int EXIT_REASON_SELF_HALT = 3;
    private static final int EXIT_REASON_OTHER_EXIT = 4;
    private static final int EXIT_REASON_OTHER_HALT = 5;
}
