// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package javax.microedition.pki;

import java.io.IOException;

// Referenced classes of package javax.microedition.pki:
//            Certificate

public class CertificateException extends IOException
{

    public CertificateException(Certificate certificate, byte byte0)
    {
        super(getMessageForReason(byte0));
        cert = certificate;
        reason = byte0;
    }

    public CertificateException(String s, Certificate certificate, byte byte0)
    {
        super(s);
        cert = certificate;
        reason = byte0;
    }

    public Certificate getCertificate()
    {
        return cert;
    }

    public byte getReason()
    {
        return reason;
    }

    static String getMessageForReason(int i)
    {
        switch(i)
        {
        case 1: // '\001'
            return "Certificate has unrecognized critical extensions";

        case 2: // '\002'
            return "Server certificate chain exceeds the length allowed by an issuer's policy";

        case 3: // '\003'
            return "Certificate is expired";

        case 4: // '\004'
            return "Intermediate certificate in the chain does not have the authority to be an intermediate CA";

        case 5: // '\005'
            return "Certificate object does not contain a signature";

        case 6: // '\006'
            return "Certificate is not yet valid";

        case 7: // '\007'
            return "Certificate does not contain the correct site name";

        case 8: // '\b'
            return "Certificate was issued by an unrecognized entity";

        case 9: // '\t'
            return "Certificate was signed using an unsupported algorithm";

        case 10: // '\n'
            return "Certificate's public key has been used in a way deemed inappropriate by the issuer";

        case 11: // '\013'
            return "Certificate in a chain was not issued by the next authority in the chain";

        case 12: // '\f'
            return "Root CA's public key is expired";

        case 13: // '\r'
            return "Certificate has a public key that is not a supported type";

        case 14: // '\016'
            return "Certificate failed verification";
        }
        return "Unknown reason (" + i + ")";
    }

    private byte reason;
    private Certificate cert;
    public static final byte BAD_EXTENSIONS = 1;
    public static final byte CERTIFICATE_CHAIN_TOO_LONG = 2;
    public static final byte EXPIRED = 3;
    public static final byte UNAUTHORIZED_INTERMEDIATE_CA = 4;
    public static final byte MISSING_SIGNATURE = 5;
    public static final byte NOT_YET_VALID = 6;
    public static final byte SITENAME_MISMATCH = 7;
    public static final byte UNRECOGNIZED_ISSUER = 8;
    public static final byte UNSUPPORTED_SIGALG = 9;
    public static final byte INAPPROPRIATE_KEY_USAGE = 10;
    public static final byte BROKEN_CHAIN = 11;
    public static final byte ROOT_CA_EXPIRED = 12;
    public static final byte UNSUPPORTED_PUBLIC_KEY_TYPE = 13;
    public static final byte VERIFICATION_FAILED = 14;
}
